package com.corba.mnq.ns;

import java.util.Vector;

import javax.swing.ListSelectionModel;

import com.corba.mnq.tool.CorbaFacility;

public class NSTable extends javax.swing.JTable {
	private ContextNode current;

	/**
	 * NSTable constructor comment.
	 */

	public NSTable() {
		super(new NSTableModel());
		setShowGrid(true);
		setAutoCreateColumnsFromModel(false);
		setDoubleBuffered(true);
		setCellSelectionEnabled(true);
		setColumnSelectionAllowed(true);
		setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	}

	/**
	 * @return the context node that is the source for this table
	 */
	public ContextNode currentSource() {
		return current;
	}

	/**
	 * 
	 * @param newData
	 *            Vector
	 */
	public void setData(Vector newData, ContextNode currentSource) {
		current = currentSource;
		((NSTableModel) super.getModel()).setDataVector(newData);
	}

	/**
	 * unbind a name and remove it from the table
	 */
	public synchronized void unbind() {
		int row = getSelectedRow();
		if (row > -1) {
			try {
				org.omg.CosNaming.NameComponent[] ncs = new org.omg.CosNaming.NameComponent[1];
				ncs[0] = new org.omg.CosNaming.NameComponent(
						(String) getValueAt(row, 0),
						(String) getValueAt(row, 1));
				current.unbind(ncs);
				update();
			} catch (Exception e) {
			}
		}
	}

	public boolean canExportIor() {
		int row = getSelectedRow();
		if (row > -1)
			return true;
		else
			return false;
	}

	public synchronized String getIOR() {
		int row = getSelectedRow();
		if (row > -1) {
			try {
				org.omg.CosNaming.NameComponent[] ncs = new org.omg.CosNaming.NameComponent[1];
				ncs[0] = new org.omg.CosNaming.NameComponent(
						(String) getValueAt(row, 0),
						(String) getValueAt(row, 1));
				String ior = CorbaFacility.orb.object_to_string(current.context
						.resolve(ncs));

				return ior;
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	/**
	 * 
	 */
	public void update() {
		if (current != null)
			current.display();
	}
}
