
package com.corba.mnq.ns;

import java.util.Vector;

public class NSTableModel extends javax.swing.table.DefaultTableModel {
	/**
	 * NSTableModel constructor.
	 */
	public NSTableModel() {
		super();
		String[] colNames = { "Name", "Kind", "Type", "Host" };
		super.setColumnIdentifiers(convertToVector(colNames));
	}

	/**
	 * getColumnCount method comment.
	 */
	public int getColumnCount() {
		return 4;
	}

	/**
	 * always returns false to make this table non-editable
	 * 
	 * @return boolean
	 * @param r
	 *            int
	 * @param c
	 *            int
	 */
	public boolean isCellEditable(int r, int c) {
		return false;
	}

	/**
	 * 
	 * @param data
	 *            Vector
	 */
	public void setDataVector(Vector newData) {
		if (newData == null)
			throw new IllegalArgumentException(
					"setDataVector() - Null parameter");

		// Add the new rows.
		dataVector = newData;

		// Make all the new rows the right length and generate a notification.
		newRowsAdded(new javax.swing.event.TableModelEvent(this, 0,
				getRowCount() - 1,
				javax.swing.event.TableModelEvent.ALL_COLUMNS,
				javax.swing.event.TableModelEvent.INSERT));
	}
}
