package org.jacorb.orb;

import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.List;
import java.util.Vector;

import org.jacorb.orb.giop.ClientConnectionManager;
import org.jacorb.orb.iiop.IIOPAddress;
import org.jacorb.orb.iiop.IIOPProfile;
import org.omg.ETF.Profile;

public class MultipleIIOPprofileSelector implements ProfileSelector {

    public static boolean inSendRequest = false;

    // store the not-active server list
    private static List badServerList = new Vector();

    /**
     * @see org.jacorb.orb.ProfileSelector#selectProfile(java.util.List,
     *      org.jacorb.orb.giop.ClientConnectionManager)
     */
    public Profile selectProfile(List profiles, ClientConnectionManager ccm) {
        int len = profiles.size();
        // always return the first profile in the list
        if (len == 1) {
            return (Profile) profiles.get(0);
        } else if (len > 1) {
            if (!inSendRequest) { return (Profile) profiles.get(0); }

            IIOPProfile pro = null;
            List notCheck = new Vector();
            for (int i = 0; i < len; i++) {
                if (profiles.get(i) instanceof IIOPProfile) {
                    System.out.println("i = " + i);
                    pro = (IIOPProfile) profiles.get(i);
                    String host = ((IIOPAddress) pro.getAddress()).getOriginalHost();
                    int port = ((IIOPAddress) pro.getAddress()).getPort();
                    if (doCreateSocket(host, port, 0, notCheck)) { return pro; }
                }
            }
            for (int i = 0; i < len; i++) {
                if (profiles.get(i) instanceof IIOPProfile) {
                    System.out.println("ii = " + i);
                    pro = (IIOPProfile) profiles.get(i);
                    String host = ((IIOPAddress) pro.getAddress()).getOriginalHost();
                    int port = ((IIOPAddress) pro.getAddress()).getPort();
                    if (doCreateSocket2(host, port, 0, notCheck)) { return pro; }
                }
            }
            System.out.println("len = " + len);
            return (Profile) profiles.get(0);
        }

        return null;
    }

    public boolean doCreateSocket(String host, int port, int timeout, List notCheck) {
        try {
            if (badServerList.contains(host + port)) {
                notCheck.add(host + port);
                return false;
            }
            Socket socket = new Socket();

            // socket.connect(new InetSocketAddress(host, port),
            // timeout);
            socket.connect(new InetSocketAddress(host, port));
        } catch (Exception e) {
            System.out.println("Host (" + host + " : " + port + ") is not reachable!");
            // e.printStackTrace();
            badServerList.add(host + port);
            return false;
        }

        return true;
    }

    public boolean doCreateSocket2(String host, int port, int timeout, List notCheck) {
        try {
            if (!notCheck.contains(host + port)) { return false; }
            Socket socket = new Socket();

            // socket.connect(new InetSocketAddress(host, port),
            // timeout);
            socket.connect(new InetSocketAddress(host, port));
            if (badServerList.contains(host + port)) {
                badServerList.remove(host + port);
            }
        } catch (Exception e) {
            System.out.println("Host (" + host + " : " + port + ") is not reachable!");
            // e.printStackTrace();
            if (!badServerList.contains(host + port)) {
                badServerList.add(host + port);
            }

            return false;
        }

        return true;
    }
}

/* EOF */
